var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var app;
(function (app) {
    /// <reference path="../models/models.ts" />
    /// <reference path="../../core/services/utilities.ts" />
    /// <reference path="../../home/interfaces.ts" />
    /// <reference path="../../core/controllers/appController.ts" />
    /// <reference path="../../../Scripts/typings/angularjs/angular.d.ts" />
    (function (contacts) {
        
        
        
        

        var ContactsController = (function (_super) {
            __extends(ContactsController, _super);
            function ContactsController(http, utilities, $scope, $location) {
                _super.call(this, $scope);
                this.http = http;
                this.utilities = utilities;
                this.$scope = $scope;
                $scope.pageSize = 10;
                $scope.pageCount = 0;
                $scope.currentPage = 1;
                $scope.search = function (pageNumber, pageSize, name, eventToRaise) {
                    http.get('/Contacts/Get', function (result) {
                        if (result.Success) {
                            $scope.contacts = result.Result.Result;
                            $scope.pageCount = result.Result.TotalPages;
                            $scope.totalFound = result.Result.TotalRows;
                            $scope.currentPage = pageNumber;
                            $scope.$broadcast(eventToRaise);
                        }
                    }, true, { pageNumber: pageNumber, pageSize: pageSize, name: name });
                };

                $scope.search(1, $scope.pageSize, $scope.name, 'searchCompleted');

                $scope.performSearch = function () {
                    $scope.search(1, $scope.pageSize, $scope.name, 'searchCompleted');
                };
                $scope.gotoPage = function (pageNumber) {
                    $scope.search(pageNumber, $scope.pageSize, $scope.name, 'pageLoadCompleted');
                };

                $scope.editContact = function (contact) {
                    $location.path("/contact/edit/" + contact.ContactId);
                };

                $scope.add = function () {
                    $location.path("/contact/edit/add");
                };

                var deleted = function (result) {
                    if (result.Success) {
                        $scope.search($scope.currentPage, $scope.pageSize, $scope.name, 'searchCompleted');
                    }
                };

                var deleteContact = function (contactType) {
                    http.post('/Contacts/Delete', contactType, deleted, true);
                };

                $scope.deleteContact = function (contact) {
                    var buttons = [
                        {
                            mehtod: function () {
                                deleteContact(contact);
                            },
                            label: 'Delete'
                        },
                        {
                            label: 'Cancel'
                        }
                    ];
                    utilities.showMessage('Delete ' + contact.LastName + ', ' + contact.FirstName + '?', buttons);
                };
            }
            return ContactsController;
        })(app.core.controllers.CoreController);

        angular.module('app.contacts.contactsController', ['app.core.services.utilities']).controller('app.contacts.contactsController', [
            'http',
            'utilities',
            '$scope',
            '$location',
            function (http, utilities, $scope, $location) {
                return new ContactsController(http, utilities, $scope, $location);
            }
        ]);
    })(app.contacts || (app.contacts = {}));
    var contacts = app.contacts;
})(app || (app = {}));
//# sourceMappingURL=contactsController.js.map
